/*
 * Copyright 2000-2015 JetBrains s.r.o.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.intellij.diff.tools.util.twoside;

import com.intellij.diff.DiffContext;
import com.intellij.diff.tools.util.EditorsDiffPanelBase;
import com.intellij.openapi.actionSystem.DataProvider;
import org.jetbrains.annotations.NotNull;

import javax.swing.*;

public class TwosideTextDiffPanel extends EditorsDiffPanelBase {
  @NotNull private final TwosideTextDiffViewer myViewer;

  public TwosideTextDiffPanel(@NotNull TwosideTextDiffViewer viewer,
                              @NotNull TwosideTextContentPanel content,
                              @NotNull DataProvider dataProvider,
                              @NotNull DiffContext context) {
    super(content, dataProvider, context);
    myViewer = viewer;
  }

  @NotNull
  @Override
  protected JComponent getCurrentEditor() {
    return myViewer.getCurrentEditor().getContentComponent();
  }
}
