package icons;

import com.intellij.openapi.util.IconLoader;

import javax.swing.*;

/**
 * Note: This file should be auto generated once build/scripts/icons.gant is part of CE.
 * https://youtrack.jetbrains.com/issue/IDEA-103558
 */
public class AndroidIcons {
  private static Icon load(String path) {
    return IconLoader.getIcon(path, AndroidIcons.class);
  }

  public static final Icon Android = load("/icons/android.png"); // 16x16
  public static final Icon Android24 = load("/icons/android24.png"); // 24x24
  public static final Icon AndroidLarge = load("/icons/androidLarge.png"); // 64x64
  public static final Icon AndroidPreview = load("/icons/androidPreview.png"); // 16x16
  public static final Icon AndroidToolWindow = load("/icons/androidToolWindow.png"); // 13x13

  public static final Icon AvdManager = load("/icons/avd_manager.png"); // 16x16
  public static final Icon SdkManager = load("/icons/sdk_manager.png"); // 16x16
  public static final Icon SdkManagerLarge = load("/icons/sdk_manager_large.png"); // 32x32
  public static final Icon NavigationEditor = load("/icons/navigation_editor.png"); // 16x16

  public static final Icon ZoomActual = load("/icons/zoomActual.png"); // 16x16
  public static final Icon ZoomFit = load("/icons/zoomFit.png"); // 16x16
  public static final Icon ZoomIn = load("/icons/zoomIn.png"); // 16x16
  public static final Icon ZoomOut = load("/icons/zoomOut.png"); // 16x16
  public static final Icon ZoomReal = load("/icons/zoomReal.png"); // 16x16
  public static final Icon Renderscript = load("/icons/renderscript.png"); // 16x16
  public static final Icon ErrorBadge = load("/icons/error-badge.png"); // 16x16
  public static final Icon WarningBadge = load("/icons/warning-badge.png"); // 16x16
  public static final Icon RenderError = load("/icons/renderError.png");
  public static final Icon RefreshPreview = load("/icons/refreshPreview.png"); // 16x16
  public static final Icon ArrowDown = load("/icons/comboArrow.png"); // 16x16
  public static final Icon NotMatch = load("/icons/notMatch.png");

  public static final Icon AndroidFile = load("/icons/android_file.png"); // 16x16
  public static final Icon Configuration = load("/icons/configuration.png"); // 16x16
  public static final Icon Activity = load("/icons/activity.png"); // 16x16
  public static final Icon Targets = load("/icons/targets.png"); // 16x16
  public static final Icon Globe = load("/icons/globe.png"); // 16x16
  public static final Icon Square = load("/icons/square.png"); // 16x16
  public static final Icon Landscape = load("/icons/landscape.png"); // 16x16
  public static final Icon Portrait = load("/icons/portrait.png"); // 16x16
  public static final Icon FlipLandscape = load("/icons/flip_landscape.png"); // 16x16
  public static final Icon FlipPortrait = load("/icons/flip_portrait.png"); // 16x16
  public static final Icon Display = load("/icons/display.png"); // 16x16
  public static final Icon Themes = load("/icons/themes.png"); // 16x16

  public static final Icon EmptyFlag = load("/icons/flags/flag_empty.png"); // 16x16

  public static final Icon GradleSync = load("/icons/gradlesync.png"); // 16x16
  public static final Icon GradleConsole = load("/icons/gradle_console.png"); // 16x16
  public static final Icon GradleConsoleToolWindow = load("/icons/gradle_console_tool_window.png"); // 13x13
  public static final Icon MavenLogo = load("/icons/mavenLogo.png"); // 16x16

  public static final Icon MemoryMonitor = load("/icons/memory_monitor.png"); // 16x16
  public static final Icon MemoryMonitorToolWindow = load("/icons/memory_monitor_tool_window.png"); // 13x13

  public static final Icon Variant = load("/icons/variant.png");

  public static final Icon AppModule = load("/icons/appModule.png");
  public static final Icon LibraryModule = load("/icons/libraryModule.png");

  // Form factors
  public static class FormFactors {
    public static final Icon Wear_16 = load("/icons/wear.png");                          // 16x16
    public static final Icon Car_16 = load("/icons/car.png");                            // 16x16
    public static final Icon Glass_16 = load("/icons/glass.png");                        // 16x16
    public static final Icon Mobile_16 = load("/icons/mobile.png");                      // 16x16
    public static final Icon Tv_16 = load("/icons/tv.png");                              // 16x16

    public static final Icon Wear_32 = load("/icons/formfactors/wear_32.png");           // 32x32
    public static final Icon Car_32 = load("/icons/formfactors/car_32.png");             // 32x32
    public static final Icon Glass_32 = load("/icons/formfactors/glass_32.png");         // 32x32
    public static final Icon Mobile_32 = load("/icons/formfactors/phone_tablet_32.png"); // 32x32
    public static final Icon Tv_32 = load("/icons/formfactors/tv_32.png");               // 32x32

    public static final Icon Wear_64 = load("/icons/formfactors/64/wear.png");           // 64x64
    public static final Icon Car_64 = load("/icons/formfactors/64/car.png");             // 64x64
    public static final Icon Glass_64 = load("/icons/formfactors/64/glass.png");         // 64x64
    public static final Icon Mobile_64 = load("/icons/formfactors/64/phone_tablet.png"); // 64x64
    public static final Icon Tv_64 = load("/icons/formfactors/64/tv.png");               // 64x64

    public static final Icon Wear_128 = load("/icons/formfactors/128/wear.png");         // 128x128
    public static final Icon Car_128 = load("/icons/formfactors/128/car.png");           // 128x128
    public static final Icon Glass_128 = load("/icons/formfactors/128/glass.png");       // 128x128
    public static final Icon Mobile_128 = load("/icons/formfactors/128/mobile.png");     // 128x128
    public static final Icon Tv_128 = load("/icons/formfactors/128/tv.png");             // 128x128
  }

  public static class Configs {
    public static final Icon Dock = load("/icons/dockmode.png");
    public static final Icon Night = load("/icons/nightmode.png");
    public static final Icon Dimension = load("/icons/dimension.png");
    public static final Icon Dpi = load("/icons/dpi.png");
    public static final Icon Height = load("/icons/height.png");
    public static final Icon Keyboard = load("/icons/keyboard.png");
    public static final Icon Language = load("/icons/language.png");
    public static final Icon Locale = load("/icons/locale.png");
    public static final Icon Mcc = load("/icons/mcc.png");
    public static final Icon Mnc = load("/icons/mnc.png");
    public static final Icon Navpad = load("/icons/navpad.png");
    public static final Icon NavpadMethod = load("/icons/navpad_method.png");
    public static final Icon Orientation = load("/icons/orientation.png");
    public static final Icon Ratio = load("/icons/ratio.png");
    public static final Icon Region = load("/icons/region.png");
    public static final Icon Size = load("/icons/size.png");
    public static final Icon SmallestWidth = load("/icons/swidth.png");
    public static final Icon TextInput = load("/icons/text_input.png");
    public static final Icon Touch = load("/icons/touch.png");
    public static final Icon Width = load("/icons/width.png");
    public static final Icon LayoutDirection = load("/icons/direction.png");
  }

  public static class Ddms {
    public static final Icon AllocationTracker = load("/icons/ddms/allocation_tracker.png"); // 16x16
    public static final Icon AttachDebugger = load("/icons/ddms/attachDebugger.png"); // 16x16
    public static final Icon Gc = load("/icons/ddms/cause_garbage_collection.png"); // 16x16
    public static final Icon DumpHprof = load("/icons/ddms/dump_hprof_file.png"); // 16x16
    public static final Icon Emulator = load("/icons/ddms/emulator.png"); // 16x16
    public static final Icon Emulator2 = load("/icons/ddms/emulator_02.png"); // 16x16
    public static final Icon FileExplorer = load("/icons/ddms/file_explorer.png"); // 16x16
    public static final Icon Heap = load("/icons/ddms/heap.png"); // 16x16
    public static final Icon HeapInfo = load("/icons/ddms/heap_info.png"); // 16x16
    public static final Icon Logcat = load("/icons/ddms/logcat.png"); // 16x16
    /** The {@link #LogcatAutoFilterSelectedPid} icon is a copy of the AllIcons.Diff.diff icon to be replaced if we get a better icon. */
    public static final Icon LogcatAutoFilterSelectedPid = load("/icons/ddms/logcat_filter_pid.png"); // 16x16
    public static final Icon RealDevice = load("/icons/ddms/real_device.png"); // 16x16
    public static final Icon ScreenCapture = load("/icons/ddms/screen_capture.png"); // 16x16
    public static final Icon StartMethodProfiling = load("/icons/ddms/start_method_profiling.png"); // 16x16
    public static final Icon Threads = load("/icons/ddms/threads.png"); // 16x16
    public static final Icon SysInfo = load("/icons/ddms/sysinfo.png"); // 16x16 - this is a copy of AllIcons.Actions.Preview
  }

  public static class Wizards {
    public static final Icon NewModuleSidePanel = load("/icons/wizards/newModule.png"); // 143x627
    public static final Icon NewProjectSidePanel = load("/icons/wizards/newProject.png"); // 143x627
    public static final Icon DefaultTemplate = load("/icons/wizards/defaultTemplate.png"); //512x512
    public static final Icon DefaultTemplate256 = load("/icons/wizards/defaultTemplate256.png"); // 256x256
    public static final Icon GithubIcon = load("/icons/wizards/github_icon.png"); // 256x256
    public static final Icon NewProjectMascot = load("/icons/wizards/welcome.png"); // 60x60
    public static final Icon NewProjectMascotGreen = load("/icons/wizards/welcome_green.png"); // 60x60
  }

  public static class Views {
    public static final Icon AbsoluteLayout = load("/icons/views/AbsoluteLayout.png"); // 16x16
    public static final Icon AdapterViewFlipper = load("/icons/views/AdapterViewFlipper.png"); // 16x16
    public static final Icon AnalogClock = load("/icons/views/AnalogClock.png"); // 16x16
    public static final Icon AutoCompleteTextView = load("/icons/views/AutoCompleteTextView.png"); // 16x16
    public static final Icon Button = load("/icons/views/Button.png"); // 16x16
    public static final Icon CalendarView = load("/icons/views/CalendarView.png"); // 16x16
    public static final Icon CheckBox = load("/icons/views/CheckBox.png"); // 16x16
    public static final Icon CheckedTextView = load("/icons/views/CheckedTextView.png"); // 16x16
    public static final Icon Chronometer = load("/icons/views/Chronometer.png"); // 16x16
    public static final Icon DatePicker = load("/icons/views/DatePicker.png"); // 16x16
    public static final Icon DeviceScreen = load("/icons/views/DeviceScreen.png"); // 16x16
    public static final Icon DialerFilter = load("/icons/views/DialerFilter.png"); // 16x16
    public static final Icon DigitalClock = load("/icons/views/DigitalClock.png"); // 16x16
    public static final Icon EditText = load("/icons/views/EditText.png"); // 16x16
    public static final Icon ExpandableListView = load("/icons/views/ExpandableListView.png"); // 16x16
    public static final Icon Fragment = load("/icons/views/fragment.png"); // 16x16
    public static final Icon FrameLayout = load("/icons/views/FrameLayout.png"); // 16x16
    public static final Icon Gallery = load("/icons/views/Gallery.png"); // 16x16
    public static final Icon GestureOverlayView = load("/icons/views/GestureOverlayView.png"); // 16x16
    public static final Icon GridLayout = load("/icons/views/GridLayout.png"); // 16x16
    public static final Icon GridView = load("/icons/views/GridView.png"); // 16x16
    public static final Icon HorizontalScrollView = load("/icons/views/HorizontalScrollView.png"); // 16x16
    public static final Icon ImageButton = load("/icons/views/ImageButton.png"); // 16x16
    public static final Icon ImageSwitcher = load("/icons/views/ImageSwitcher.png"); // 16x16
    public static final Icon ImageView = load("/icons/views/ImageView.png"); // 16x16
    public static final Icon Include = load("/icons/views/include.png"); // 16x16
    public static final Icon LinearLayout = load("/icons/views/LinearLayout.png"); // 16x16
    public static final Icon VerticalLinearLayout = load("/icons/views/VerticalLinearLayout.png"); // 16x16
    public static final Icon LinearLayout3 = load("/icons/views/LinearLayout3.png"); // 16x16
    public static final Icon ListView = load("/icons/views/ListView.png"); // 16x16
    public static final Icon MediaController = load("/icons/views/MediaController.png"); // 16x16
    public static final Icon MultiAutoCompleteTextView = load("/icons/views/MultiAutoCompleteTextView.png"); // 16x16
    public static final Icon Merge = load("/icons/views/merge.png"); // 16x16
    public static final Icon NumberPicker = load("/icons/views/NumberPicker.png"); // 16x16
    public static final Icon ProgressBar = load("/icons/views/ProgressBar.png"); // 16x16
    public static final Icon QuickContactBadge = load("/icons/views/QuickContactBadge.png"); // 16x16
    public static final Icon RadioButton = load("/icons/views/RadioButton.png"); // 16x16
    public static final Icon RadioGroup = load("/icons/views/RadioGroup.png"); // 16x16
    public static final Icon RatingBar = load("/icons/views/RatingBar.png"); // 16x16
    public static final Icon RelativeLayout = load("/icons/views/RelativeLayout.png"); // 16x16
    public static final Icon RequestFocus = load("/icons/views/requestFocus.png"); // 16x16
    public static final Icon ScrollView = load("/icons/views/ScrollView.png"); // 16x16
    public static final Icon SearchView = load("/icons/views/SearchView.png"); // 16x16
    public static final Icon SeekBar = load("/icons/views/SeekBar.png"); // 16x16
    public static final Icon SlidingDrawer = load("/icons/views/SlidingDrawer.png"); // 16x16
    public static final Icon Space = load("/icons/views/Space.png"); // 16x16
    public static final Icon Spinner = load("/icons/views/Spinner.png"); // 16x16
    public static final Icon StackView = load("/icons/views/StackView.png"); // 16x16
    public static final Icon SurfaceView = load("/icons/views/SurfaceView.png"); // 16x16
    public static final Icon Switch = load("/icons/views/Switch.png"); // 16x16
    public static final Icon TabHost = load("/icons/views/TabHost.png"); // 16x16
    public static final Icon TableLayout = load("/icons/views/TableLayout.png"); // 16x16
    public static final Icon TableRow = load("/icons/views/TableRow.png"); // 16x16
    public static final Icon TabWidget = load("/icons/views/TabWidget.png"); // 16x16
    public static final Icon TextClock = load("/icons/views/TextClock.png"); // 16x16
    public static final Icon TextSwitcher = load("/icons/views/TextSwitcher.png"); // 16x16
    public static final Icon TextureView = load("/icons/views/TextureView.png"); // 16x16
    public static final Icon TextView = load("/icons/views/TextView.png"); // 16x16
    public static final Icon TimePicker = load("/icons/views/TimePicker.png"); // 16x16
    public static final Icon ToggleButton = load("/icons/views/ToggleButton.png"); // 16x16
    public static final Icon TwoLineListItem = load("/icons/views/TwoLineListItem.png"); // 16x16
    public static final Icon Unknown = load("/icons/views/customView.png"); // 16x16
    public static final Icon VideoView = load("/icons/views/VideoView.png"); // 16x13
    public static final Icon View = load("/icons/views/View.png"); // 16x16
    public static final Icon ViewAnimator = load("/icons/views/ViewAnimator.png"); // 16x16
    public static final Icon ViewFlipper = load("/icons/views/ViewFlipper.png"); // 16x16
    public static final Icon ViewStub = load("/icons/views/ViewStub.png"); // 16x16
    public static final Icon ViewSwitcher = load("/icons/views/ViewSwitcher.png"); // 16x16
    public static final Icon WebView = load("/icons/views/WebView.png"); // 16x16
    public static final Icon ZoomButton = load("/icons/views/ZoomButton.png"); // 16x16
    public static final Icon ZoomControls = load("/icons/views/ZoomControls.png"); // 16x16
  }

  public static class Versions {
    public static final Icon Froyo = load("/icons/versions/Froyo.png"); // 512x512
    public static final Icon Gingerbread = load("/icons/versions/Gingerbread.png"); // 512x512
    public static final Icon Honeycomb = load("/icons/versions/Honeycomb.png"); // 512x512
    public static final Icon IceCreamSandwich = load("/icons/versions/IceCreamSandwich.png"); // 512x512
    public static final Icon JellyBean = load("/icons/versions/Jelly Bean.png"); // 512x512
    public static final Icon KitKat = load("/icons/versions/KitKat.png"); // 512x512
    public static final Icon Lollipop = load("/icons/versions/Lollipop.png");
  }
}
